# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from smarthome_media_msgs/StateData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import smarthome_media_msgs.msg
import genpy
import std_msgs.msg

class StateData(genpy.Message):
  _md5sum = "dfceb2b3b4bf444401a6e5cf7265fb58"
  _type = "smarthome_media_msgs/StateData"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """## State data media message
## Common state of media connected object

Header header

# State    0: Unknown, 1: Init, 2: Enable, 3: Shutdown
uint32 state

# Input    (tv/tuner, player, ext1, HDMI3, VGA, HP, ext...)
MonitorInfo monitor

# Audio data
SpeakerInfo speaker

# Player data
PlayerInfo player

uint32 UNKNOWN=0
uint32 INIT=1
uint32 ENABLE=2
uint32 SHUTDOWN=3
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: smarthome_media_msgs/MonitorInfo
## Statedata components
## sub-type of Monitor capability

# Resolution width x height in pixel
uint32 height
uint32 wigth

# Source of stream (video/image/channel)
string source
================================================================================
MSG: smarthome_media_msgs/SpeakerInfo
## Statedata components
## sub-type of Speaker capability

# Output 
uint32 output

# Level (in decibel SPL)
uint32 level

# Muted
bool muted

# Channel
string channel

# Source of stream
string source


================================================================================
MSG: smarthome_media_msgs/PlayerInfo
## Statedata components
## sub-type of Player capability

# State    0: Unknown, 1: stop, 2: play, 3: pause, 4: fastforward, 5: fastbackward, 6: moveto
uint32 state

# Speed play (or forward / reverse)
int32 speed

# Position
duration stamp
duration totaltime

bool canseek
bool subtitleenabled
int32 mediaid
MediaType mediatype

string title
string file
string thumbnail
================================================================================
MSG: smarthome_media_msgs/MediaType
## Service call
## see XBMC structure or Isod

string value

string UNKNOW=unknow
string VIDEO_MOVIE=movie
string VIDEO_TVSHOW=tvshow
string VIDEO_TVSHOW_EPISODE=episode
string AUDIO_SONG=song
string AUDIO_ALBUM=album"""
  # Pseudo-constants
  UNKNOWN = 0
  INIT = 1
  ENABLE = 2
  SHUTDOWN = 3

  __slots__ = ['header','state','monitor','speaker','player']
  _slot_types = ['std_msgs/Header','uint32','smarthome_media_msgs/MonitorInfo','smarthome_media_msgs/SpeakerInfo','smarthome_media_msgs/PlayerInfo']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,state,monitor,speaker,player

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(StateData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.state is None:
        self.state = 0
      if self.monitor is None:
        self.monitor = smarthome_media_msgs.msg.MonitorInfo()
      if self.speaker is None:
        self.speaker = smarthome_media_msgs.msg.SpeakerInfo()
      if self.player is None:
        self.player = smarthome_media_msgs.msg.PlayerInfo()
    else:
      self.header = std_msgs.msg.Header()
      self.state = 0
      self.monitor = smarthome_media_msgs.msg.MonitorInfo()
      self.speaker = smarthome_media_msgs.msg.SpeakerInfo()
      self.player = smarthome_media_msgs.msg.PlayerInfo()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.state, _x.monitor.height, _x.monitor.wigth))
      _x = self.monitor.source
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2IB.pack(_x.speaker.output, _x.speaker.level, _x.speaker.muted))
      _x = self.speaker.channel
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.speaker.source
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_I5i2Bi.pack(_x.player.state, _x.player.speed, _x.player.stamp.secs, _x.player.stamp.nsecs, _x.player.totaltime.secs, _x.player.totaltime.nsecs, _x.player.canseek, _x.player.subtitleenabled, _x.player.mediaid))
      _x = self.player.mediatype.value
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.player.title
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.player.file
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.player.thumbnail
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.monitor is None:
        self.monitor = smarthome_media_msgs.msg.MonitorInfo()
      if self.speaker is None:
        self.speaker = smarthome_media_msgs.msg.SpeakerInfo()
      if self.player is None:
        self.player = smarthome_media_msgs.msg.PlayerInfo()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.state, _x.monitor.height, _x.monitor.wigth,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.monitor.source = str[start:end].decode('utf-8')
      else:
        self.monitor.source = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.speaker.output, _x.speaker.level, _x.speaker.muted,) = _struct_2IB.unpack(str[start:end])
      self.speaker.muted = bool(self.speaker.muted)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.speaker.channel = str[start:end].decode('utf-8')
      else:
        self.speaker.channel = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.speaker.source = str[start:end].decode('utf-8')
      else:
        self.speaker.source = str[start:end]
      _x = self
      start = end
      end += 30
      (_x.player.state, _x.player.speed, _x.player.stamp.secs, _x.player.stamp.nsecs, _x.player.totaltime.secs, _x.player.totaltime.nsecs, _x.player.canseek, _x.player.subtitleenabled, _x.player.mediaid,) = _struct_I5i2Bi.unpack(str[start:end])
      self.player.canseek = bool(self.player.canseek)
      self.player.subtitleenabled = bool(self.player.subtitleenabled)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.player.mediatype.value = str[start:end].decode('utf-8')
      else:
        self.player.mediatype.value = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.player.title = str[start:end].decode('utf-8')
      else:
        self.player.title = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.player.file = str[start:end].decode('utf-8')
      else:
        self.player.file = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.player.thumbnail = str[start:end].decode('utf-8')
      else:
        self.player.thumbnail = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.state, _x.monitor.height, _x.monitor.wigth))
      _x = self.monitor.source
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2IB.pack(_x.speaker.output, _x.speaker.level, _x.speaker.muted))
      _x = self.speaker.channel
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.speaker.source
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_I5i2Bi.pack(_x.player.state, _x.player.speed, _x.player.stamp.secs, _x.player.stamp.nsecs, _x.player.totaltime.secs, _x.player.totaltime.nsecs, _x.player.canseek, _x.player.subtitleenabled, _x.player.mediaid))
      _x = self.player.mediatype.value
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.player.title
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.player.file
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.player.thumbnail
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.monitor is None:
        self.monitor = smarthome_media_msgs.msg.MonitorInfo()
      if self.speaker is None:
        self.speaker = smarthome_media_msgs.msg.SpeakerInfo()
      if self.player is None:
        self.player = smarthome_media_msgs.msg.PlayerInfo()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.state, _x.monitor.height, _x.monitor.wigth,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.monitor.source = str[start:end].decode('utf-8')
      else:
        self.monitor.source = str[start:end]
      _x = self
      start = end
      end += 9
      (_x.speaker.output, _x.speaker.level, _x.speaker.muted,) = _struct_2IB.unpack(str[start:end])
      self.speaker.muted = bool(self.speaker.muted)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.speaker.channel = str[start:end].decode('utf-8')
      else:
        self.speaker.channel = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.speaker.source = str[start:end].decode('utf-8')
      else:
        self.speaker.source = str[start:end]
      _x = self
      start = end
      end += 30
      (_x.player.state, _x.player.speed, _x.player.stamp.secs, _x.player.stamp.nsecs, _x.player.totaltime.secs, _x.player.totaltime.nsecs, _x.player.canseek, _x.player.subtitleenabled, _x.player.mediaid,) = _struct_I5i2Bi.unpack(str[start:end])
      self.player.canseek = bool(self.player.canseek)
      self.player.subtitleenabled = bool(self.player.subtitleenabled)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.player.mediatype.value = str[start:end].decode('utf-8')
      else:
        self.player.mediatype.value = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.player.title = str[start:end].decode('utf-8')
      else:
        self.player.title = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.player.file = str[start:end].decode('utf-8')
      else:
        self.player.file = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.player.thumbnail = str[start:end].decode('utf-8')
      else:
        self.player.thumbnail = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_2IB = struct.Struct("<2IB")
_struct_I5i2Bi = struct.Struct("<I5i2Bi")
